VERSION 8000;;8408
* Allg_BspDialogAchsfelder.CSX    30.11.11
* -----------------------------------------------------------------------------
* @filedoc
* @file Allg_BspDialogAchsfelder.CSX
* @brief <Dialog mit Feldern fr Achsauswahl und achsabhngigen Daten>
* 
* <Beispielskript mit Dialogfunktion fr Achs- und achsabhngige Felder.
*  ber einen Parameter bei Aufruf des Dialogs wird gesteuert, ob nur vorhandene Daten
*  ausgewhlt (0) oder auch neue eingegeben (1) werden knnen. 
*  ber 2 Checkboxen ist steuerbar, ob Stationsdaten- oder Profildatenfelder aktiv oder 
*  passiv geschaltet sind.
*  Die Eingabewerte werden bei Dialogbesttigung mit ok in der Datei "Achsdialog.QPS" gespeichert. 
*  Bei erneutem Aufruf Skripts werden die Felder mit den gespeicherten Werten vorbelegt.>
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author Ch
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
* 
$CHECKLEVEL 7
BILDSCHIRM GRAFIK
* Deklarationen
SYMBOLE * Ret;AchsNr;AnfStat;EndStat;Stat1;ListeStat;Gra1;Gel1;Brt1;Que1
SYMBOLE * Lis1;Ueb1;Ges1;Abs1;ProLin1;ProPkt1
* Vorbelegung
AchsNr = 1
Stat1 = 1
ListeStat = 1
Gra1 = 1
Gel1 = 1
Brt1 = 1
Que1 = 1
Lis1 = 1
Ueb1 = 1
Ges1 = 1
Abs1 = 1
ProLin1 = 10
ProPkt1 = 0

* -----------------------------------------------------------------------------

* Dialog aufrufen
Achsdaten_Dialog(0)          | 0 = nur vorhandene Daten / 1 = neue Daten

STOP
* -----------------------------------------------------------------------------
* @function Achsdaten_Dialog
* @brief <Dialog mit Feldern fr Achsauswahl und achsabhngigen Daten>
* @param Eingabe: 0: es knnen nur vorhandene Daten gewhlt werden
*                 1: es knnen auch neue Daten eingegben werden. Prfung bei Auswahl vorh. Daten.
* @ingroup
* @author Ch
* @endfunction
FUNKTION Achsdaten_Dialog: Eingabe
* Deklarationen
  SYMBOLE /DLG_WINDOW/ Dialog
  SYMBOLE /DLG_CHECKBOX/ CheckS ;CheckP
  SYMBOLE /DLG_FRAME/ Frame1; Frame2;Frame3;Frame4
  * Achse
  SYMBOLE /DLG_ALIGNMENT/ Achse
  * Stationsdaten
  SYMBOLE /DLG_CHAINAGE/  Station
  SYMBOLE /DLG_CHAINAGERANGE/ Bereich
  SYMBOLE /DLG_CHAINAGELIST/ Statliste
  SYMBOLE /DLG_VERTALIGN/ Gradiente
  SYMBOLE /DLG_PROFILE/   Gelaende
  SYMBOLE /DLG_WIDTH/     Breite
  SYMBOLE /DLG_CROSSFALL/ Querneig
  SYMBOLE /DLG_LIST/      Liste
  SYMBOLE /DLG_CANT/      Ueberh
  SYMBOLE /DLG_SPEED/     Geschwind
  SYMBOLE /DLG_SECTION/   Abschnitt
  * Profil
  SYMBOLE /DLG_XSECTIONLINE/ ProfilLinie
  SYMBOLE /DLG_XSECTIONPOINT/ ProfilPunkt
  * 
  EXTERN * Ret;AchsNr;AnfStat;EndStat;Stat1;ListeStat;Gra1      | auerhalb der Funktion definierte Symbole
  EXTERN * Gel1;Brt1;Que1;Lis1;Ueb1;Ges1;Abs1;ProLin1;ProPkt1   | auerhalb der Funktion definierte Symbole
  SYMBOLE * CheckStat;CheckProf
* Vorbelegung Checkboxen
  CheckStat = 1
  CheckProf = 1
  * Eingagewerte speichern in QPS-Datei 
  NEUSYMBOLE 0
  EINSYMBOLE "Achsdialog.QPS"

* .................Dialog anlegen
  Dialog =   NEWOBJECT /DLG_WINDOW/
  Dialog.SetCaption("Achsdaten")
  
* .................Rahmen anlegen
  Frame1 = Dialog.CreateFrame(0;"Achse")
  Frame2 = Dialog.CreateFrame(0)
  Frame3 = Dialog.CreateFrame(0;"Stationsdaten")
  Frame3.SetSize(100)                            |Rahmenbreite festlegen
  Frame4 = Dialog.CreateFrame(0;"Profildaten")
  Frame4.SetSize(100)
*..................Checkbox fr Auswahl Stationsdaten in Frame2
  CheckS = NEWOBJECT  /DLG_CHECKBOX/
  CheckS.SetBoxLabel("Stationsdaten")
  CheckS.SetValue(CheckStat)
  Frame2.AddField(CheckS)
*..................Checkbox fr Auswahl Profildaten
  CheckP = NEWOBJECT  /DLG_CHECKBOX/
  CheckP.AppendRight()                           | 2.Checkbox rechts neben die erste platzieren
  CheckP.SetBoxLabel("Profildaten")
  CheckP.SetValue(CheckProf)
  Frame2.AddField(CheckP)
*..................Felder fr Achse und Stationsbereich in Frame1
  Achse = NewObject /DLG_ALIGNMENT/
  Achse.SetLabel("Achse:")
  Achse.SetNumber(AchsNr)
  Achse.SetId(1)
  WENN Eingabe DANN  Achse.EnableNew()
  Frame1.AddField(Achse)
  * Stationsbereich
  Bereich = NewObject /DLG_CHAINAGERANGE/
  Bereich.SetLabel("Anfang, Ende:")
  Bereich.SetAlignmentField(Achse)
  Bereich.SetStartChainage(AnfStat)
  Bereich.SetEndChainage(EndStat)
  Frame1.AddField(Bereich)
*..................Felder fr Stationsdaten in Frame3
  * Station
  Station = NewObject /DLG_CHAINAGE/
  Station.SetLabel("Station:")
  Station.SetAlignmentField(Achse)               | Achsbezug  
  Station.SetChainage(Stat1)
  Station.AddObserveField(CheckS;1;1;1)          | Feld ist nur aktiv, wenn Checkbox fr Stationsdaten aktiv
  Frame3.AddField(Station)
  * Stationsliste
  Statliste = NewObject /DLG_CHAINAGELIST/
  Statliste.SetLabel("Stationsliste:")
  Statliste.SetAlignmentField(Achse)
  Statliste.SetNumber(ListeStat)
  Statliste.EnableZero()
  *Statliste.EnableUndef()
  WENN Eingabe DANN     Statliste.EnableNew()
  Statliste.AddObserveField(CheckS;1;1;1)
  Frame3.AddField(Statliste)
  * Breite 
  Breite = NewObject /DLG_WIDTH/
  Breite.SetLabel("Breiteband:")
  Breite.SetAlignmentField(Achse)
  Breite.SetNumber(Brt1)
  Breite.EnableZero()
  *Breite.EnableUndef()
  WENN Eingabe DANN     Breite.EnableNew()
  Breite.AddObserveField(CheckS;1;1;1)
  Frame3.AddField(Breite)
  * Querneigung 
  Querneig = NewObject /DLG_CROSSFALL/
  Querneig.SetLabel("Querneigungsband:")
  Querneig.SetAlignmentField(Achse)
  Querneig.SetNumber(Que1)
  Querneig.EnableZero()
  *Querneig.EnableUndef()
  WENN Eingabe DANN     Querneig.EnableNew()
  Querneig.AddObserveField(CheckS;1;1;1)
  Frame3.AddField(Querneig)
  * berhhung 
  Ueberh = NewObject /DLG_CANT/
  Ueberh.SetLabel("berhhungsband:")
  Ueberh.SetAlignmentField(Achse)
  Ueberh.SetNumber(Ueb1)
  *Ueberh.EnableUndef()
  Ueberh.EnableZero()
  WENN Eingabe DANN      Ueberh.EnableNew()
  Ueberh.SetDescription("neues berhhungsband")
  Ueberh.AddObserveField(CheckS;1;1;1)
  Frame3.AddField(Ueberh)
  * Steuerliste 
  Liste = NewObject /DLG_LIST/
  Liste.SetLabel("Steuerliste:")
  Liste.SetAlignmentField(Achse)
  Liste.SetNumber(Lis1)
  Liste.SetDescription("neue Steuerliste")
  Liste.EnableZero()
  *Liste.EnableUndef()
  WENN Eingabe DANN     Liste.EnableNew()
  Liste.AddObserveField(CheckS;1;1;1)    
  Frame3.AddField(Liste)
* Abschnitt 
  Abschnitt = NewObject /DLG_SECTION/
  Abschnitt.SetLabel("Abschnittsband:")
  Abschnitt.SetAlignmentField(Achse)
  Abschnitt.SetNumber(Abs1)
  Abschnitt.EnableZero()
  *Abschnitt.EnableUndef()
  WENN Eingabe DANN     Abschnitt.EnableNew()
  Abschnitt.AddObserveField(CheckS;1;1;1)
  Frame3.AddField(Abschnitt)
* Geschwindigkeit
  Geschwind = NewObject /DLG_SPEED/
  Geschwind.SetLabel("Geschwindigkeitsband:")
  Geschwind.SetAlignmentField(Achse)
  Geschwind.SetNumber(Ges1)
  *Geschwind.EnableUndef()
  Geschwind.EnableZero()
  WENN Eingabe DANN     Geschwind.EnableNew()
  Geschwind.AddObserveField(CheckS;1;1;1)
  Frame3.AddField(Geschwind)
*..................Felder fr Profildaten in Frame4
 * Gradiente + Bezeichnung
  Gradiente = NewObject /DLG_VERTALIGN/
  Gradiente.SetLabel("Gradiente:")
  Gradiente.SetAlignmentField(Achse)             | Achsbezug 
  Gradiente.SetNumber(Gra1)                      | Feld vorbelegen
  Gradiente.EnableZero()                         | Eingabe 0 (keine Datei) zulassen  
  *Gradiente.EnableUndef()                       | leeres Eingabefeld zulassen
  WENN Eingabe DANN   Gradiente.EnableNew()      | bei Dialogaufruf mit (1) ist Eingabe einer neuen Gradiente mglich
  Gradiente.AddObserveField(CheckP;1;1;1)        | Feld ist nur aktiv, wenn Checkbox fr Stationsdaten aktiv
  Frame4.AddField(Gradiente)
  * Gelnde + Bezeichnung
  Gelaende = NewObject /DLG_PROFILE/
  Gelaende.SetLabel("Gelndelinie:")
  Gelaende.SetAlignmentField(Achse)
  Gelaende.SetNumber(Gel1)
  Gelaende.EnableZero()
  *Gelaende.EnableUndef()
  WENN Eingabe DANN    Gelaende.EnableNew()
  Gelaende.AddObserveField(CheckP;1;1;1)
  Frame4.AddField(Gelaende)
* Profillinie 
  ProfilLinie = NewObject /DLG_XSECTIONLINE/
  ProfilLinie.SetLabel("Querprofillinie:")
  ProfilLinie.SetAlignmentField(Achse)
  ProfilLinie.SetNumber(ProLin1)
  WENN Eingabe DANN    ProfilLinie.EnableNew()
  ProfilLinie.AddObserveField(CheckP;1;1;1)
  Frame4.AddField(ProfilLinie)
* Profillinienpunkt 
  ProfilPunkt = NewObject /DLG_XSECTIONPOINT/
  ProfilPunkt.SetLabel("Querprofilpunkt:         ")
  ProfilPunkt.SetAlignmentField(Achse)
  ProfilPunkt.SetNumber(ProPkt1)
  ProfilPunkt.SetXSectionLineField(ProfilLinie)
  WENN Eingabe DANN    ProfilPunkt.EnableNew()
  ProfilPunkt.AddObserveField(CheckP;1;1;1)
  Frame4.AddField(ProfilPunkt)

*..................Dialog ausfhren
  Ret = Dialog.DoDialog()

*..................Ergebnis
  WENN Ret DANN
    AchsNr = Achse.GetNumber()
    AnfStat = Bereich.GetStartChainage()
    EndStat = Bereich.GetEndChainage()
    CheckStat = CheckS.GetValue()
    CheckProf = CheckP.GetValue()
    Stat1 = Station.GetChainage()
    ListeStat = StatListe.GetNumber()
    Gra1 = Gradiente.GetNumber()
    Gel1 = Gelaende.GetNumber()
    Brt1 = Breite.GetNumber()  
    Que1 = Querneig.GetNumber()
    Lis1 = Liste.GetNumber()
    Ueb1 = Ueberh.GetNumber()
    Ges1 = Geschwind.GetNumber()
    Abs1 = Abschnitt.GetNumber()
    ProLin1 = ProfilLinie.GetNumber()
    ProPkt1 = ProfilPunkt.GetNumber()
  WEITER
  AUSSYMBOLE CheckStat;CheckProf;AchsNr;AnfStat;EndStat;Stat1;ListeStat | Werte in "Achsdialog.QPS" ausgeben
  AUSSYMBOLE Gra1;Gel1;Brt1;Que1;Lis1;Ueb1;Ges1;Abs1;ProLin1;ProPkt1  
  ZURCK Ret
ENDE FUNKTION 
* -----------------------------------------------------------------------------






